/*
 * myDir.cpp
 *
 *  Created on: Jul 6, 2014
 *      Author: nick
 */

#include "myDir.h"
#include "dirent.h"
#include <cstring>
#include "myS3Common.h"

using namespace std;


bool doGetAllFiles(size_t len, const string& strPath, S3ObjSet& setFiles)
{
	DIR *dir;
	if ((dir = opendir(strPath.c_str())) != NULL)
	{
		struct dirent *ent;
		while ((ent = readdir (dir)) != NULL)
		{
			//printf("%s\n", ent->d_name);
			string str = strPath;
			S3Obj s3Obj;
			if (str[str.size()-1] != '/')
			{
				str += "/";
			}
			str += ent->d_name;
			switch (ent->d_type)
			{
			case DT_DIR:
				if (strcmp(ent->d_name, ".") != 0 && strcmp(ent->d_name, "..") != 0)
				{
					//printf ("[%s]    [%s]\n", ent->d_name, str.c_str());
					if (!doGetAllFiles(len, str, setFiles))
					{
						return false;
					}
				}
				break;
			case DT_REG:
				if (!populateS3Obj(str, str.substr(len), s3Obj))
				{
					return false;
				}
				setFiles.insert(s3Obj);
				break;
			}
		}
		closedir (dir);
	}
	else
	{
		perror (strPath.c_str());
		return false;
	}
	return true;

}

bool getAllFiles(const string& strPath, S3ObjSet& setFiles)
{
	return doGetAllFiles(strPath.size(), strPath, setFiles);
}
