/*
 * myLibS3.cpp
 *
 *  Created on: Jun 28, 2014
 *      Author: nick
 */



#include "myLibS3.h"
#include "myListObj.h"
#include "myGetObj.h"
#include "myPutObj.h"
#include "myDir.h"
#include "myS3Common.h"

using namespace std;



void test1()
{
	S3ObjSet s3Set;
	string strBucket = "diabloforum";
	if (listObjects(strBucket, s3Set))
	{
		//cout << "successfully get "<< s3Vect.size() << " objects of bucket of " << strBucket << endl;
		printS3ObjSet(s3Set);
	}
}

void test2()
{
	if (getObject("diabloforum", "rules.txt", "nick-test.txt"))
	{
		cout << " successful " << endl;
	}
}

void put_test()
{
	if (putObject("huangqingzhe", "index.htm", "/home/nick/Downloads/diabloforum/public_html/index.htm"))
	{
		cout << " successful" << endl;
	}
}

void test4()
{
	S3ObjSet s3List;
	if (getAllFiles("/home/nick/Downloads/diabloforum/public_html", s3List))
	{
		cout << " successful " << endl;
		printS3ObjSet(s3List);
	}
}

void sync(const string& strBucket, const string& strRootPath)
{
	S3ObjSet localList, remoteList;
	if (!getAllFiles(strRootPath, localList))
	{
		cout << " getAllFiles failed " << endl;
		return;
	}
	if (!listObjects(strBucket, remoteList))
	{
		cout << " listObjects failed " << endl;
		return;
	}
	//cout << "*****************************locallist*************************" << endl;
	//printS3ObjSet(localList);
	//cout << "**************************remoteList*****************************" << endl;
	//printS3ObjSet(remoteList);

	for (S3ObjSet::const_iterator localIt = localList.begin(); localIt != localList.end(); localIt ++)
	{
		SyncDirectionEnum direction = DirectionNone;
		S3ObjSet::const_iterator remoteIt = remoteList.find(*localIt);
		if (remoteIt != remoteList.end())
		{
			// found it
			if (remoteIt->size != localIt->size || (remoteIt->tag.size() != 0 && remoteIt->tag.compare(localIt->tag) != 0))
			{
				direction = DirectionUpload;
			}
		}
		else
		{
			cout << "DirectionUpload:" << localIt->key << endl << localIt->size << localIt->time << endl;
			direction = DirectionUpload; // upload
		}
		string strPath = strRootPath + localIt->key;
		string strPersonal = strRootPath + "personal";
		S3CannedAcl acl = S3CannedAclPublicRead;
		switch (direction)
		{
		case DirectionUpload:
			if (strPath.compare(0, strPersonal.size(), strPersonal) == 0)
			{
				acl = S3CannedAclPrivate;
			}
			cout << "upload:" << strPath << " ; " << localIt->key << endl;
			if (!putObject(strBucket, localIt->key, strPath, acl))
			{
				cout << "upload error: bucket: " << strBucket << " key:" << strPath << " path:" << localIt->key << endl;
			}
			break;
		default:
			break;
		}
	}
/*
	for (S3ObjSet::const_iterator remoteIt = remoteList.begin(); remoteIt != remoteList.end(); remoteIt ++)
	{
		SyncDirectionEnum direction = DirectionNone; // nothing

		S3ObjSet::const_iterator localIt = localList.find(*remoteIt);
		if (localIt == localList.end())
		{
			direction = DirectionDownload;
		}
		string strPath = strRootPath + remoteIt->key;

		switch (direction)
		{
		case DirectionDownload:
			if (ensureParentDirectory(strPath))
			{
				cout << "download:" << localIt->key << "; " << strPath << endl;
				if (!getObject(strBucket, localIt->key, strPath))
				{
					cout << "download error: bucket: " << strBucket << " key:" << strPath << " path:" << localIt->key << endl;
				}
			}
			break;
		default:

			break;
		}
	}
	*/
}

void upload(const string& strBucket, const string& strInputRootPath)
{
	S3ObjSet localList;
	string strRootPath = strInputRootPath;
	if (strRootPath.size() > 0 && strRootPath[strRootPath.size()-1] != '/')
	{
		strRootPath.push_back('/');
	}
	if (!getAllFiles(strRootPath, localList))
	{
		cout << " getAllFiles failed " << endl;
		return;
	}

	for (S3ObjSet::const_iterator localIt = localList.begin(); localIt != localList.end(); localIt ++)
	{
		string strPath = strRootPath + localIt->key;
		string strPersonal = strRootPath + "personal";
		S3CannedAcl acl = S3CannedAclPublicRead;

		if (strPath.compare(0, strPersonal.size(), strPersonal) == 0)
		{
			acl = S3CannedAclPrivate;
		}
		cout << "upload:" << strPath << " ; " << localIt->key << endl;
		if (!putObject(strBucket, localIt->key, strPath, acl))
		{
			cout << "upload error: bucket: " << strBucket << " key:" << strPath << " path:" << localIt->key << endl;
		}
	}

}

int main1()
{
	const string& strBucket = "www.staroceans.com";
	const string& strRootPath = "/home/nick/Downloads/diabloforum/public_html/";
	upload(strBucket, strRootPath);
	//ensureParentDirectry("/home/nick/dir/./tmp//tmp//tm././//../dir/d");

	return 0;

}

int main()
{
	//test1();
	//put_test();
	//upload("huangqingzhe", "/home/nick/Downloads/diabloforum/public_html/");
	sync("www.staroceans.org", "/home/nick/Downloads/diabloforum/public_html/");
	return 0;
}


